/*
 * Groups.h
 *
 *  Created on: 12/10/2016
 *      Author: augalves
 */

#ifndef GROUPS_H_
#define GROUPS_H_


/**
 * \file
 * \brief This file defines the different modules for doxygen documentation.
 */

/**
 * \defgroup manual Users guide
 */

/**
 * \defgroup fit Data fitting
 * \brief Data fit functionalities of Hydra
 */

/**
 * \defgroup random Random number generation
 * \brief Random mumber generation and pdf sampling functionalities
 */

/**
 * \defgroup phsp Phase-Space Monte Carlo
 * \brief Kinematics of particle decays and generation of phase-space Monte Carlo samples
 */

/**
 * \defgroup functor Functor Arithmetic
 * \brief Functor base types and arithmetic operations
 */

/**
 * \defgroup numerical_integration Numerical integration
 * \brief Basic types and definitions
 */

/**
 * \defgroup generic Generic
 * \brief Generic types, definitions and algorithms
 */

/**
 * \defgroup policy Policy
 * \brief Policies
 */


#endif /* GROUPS_H_ */
